﻿if(app.documents.length==0){
alert("InDesignドキュメントを開いてから実行してください。");
exit() ;
}

var ret = Window.confirm("検索設定（検索範囲以外）は検索置換ダイアログの「正規表現タブ」で事前におこなってください。\r※いったん作業キャンセルは「No」をクリック", false, "実行確認");
if(ret==false){exit();}
var doc = app.documents[0];
var docLength = app.documents.length;
//alert(docLength);
var stAry = [ "すべてのドキュメント" , "ドキュメント" , "ストーリー" , "選択範囲"  ];

//ここからダイアログ（Window）の設定
var dlg = new Window('dialog', "検索範囲", undefined, {borderless: false});	//borderlessは上の帯の有無らしい

//エリア
dlg.panel = dlg.add('panel');
dlg.panel.alignChildren = 'left';

//ドロップダウンリスト
var ddl11 = dlg.panel.add('dropdownlist',  [0,0,240,23], stAry);
ddl11.selection = 1;	//何番目を初期表示とするか（らしい）

//buttonエリア
dlg.group = dlg.add('group');
var ok_btn = dlg.group.add('button', undefined,"OK", {name:'ok'});
var can_btn = dlg.group.add('button',undefined,"Cancel", {name:'cancel'});

ok_btn.onClick = function () {
var setting_obj = {};
can = false ;
dlg.close();
}
can_btn.onClick = function () {
can = true ;
dlg.close();
}
dlg.show();
if(can == true){exit();}

var searchRange = stAry[ddl11.selection.index] ;
var range ;
if( searchRange == "すべてのドキュメント" ){ range = app };
if( searchRange == "ドキュメント" ){ range = doc };
if( searchRange == "ストーリー" ){
//storyまとめ
if(doc.selection[0]=="[object Cell]" ){
    range = doc.selection[0].parent.parent;
    }else if(doc.selection[0]=="[object Table]"){
            range = doc.selection[0].parent;
            }else if(doc.selection[0]=="[object TextFrame]")
                {for( i=0 ; i<doc.selection.length ; i++){
                    range = doc.selection[i].parentStory;
                    }
                }else{
                    range = doc.selection[0].parentStory;
                    }
                };
if( searchRange == "選択範囲" ){ range = doc.selection[0] };

//外部テキストファイルを用意
saveFolderPath = app.documents[0].filePath; // ドキュメントの保存フォルダ
fileObj = new File(saveFolderPath +"/【"+app.documents[0].name+"】.txt");
fileObj.encoding="UTF8";

//一覧を生成
var doc = app.documents[0] ;
var myList=new String;
myList=("");

//綴じ方を確認（縦組みか横組みか／ページの流れ）→toji
var toji ;
if(doc.documentPreferences.pageBinding==PageBindingOptions.RIGHT_TO_LEFT){toji="tate"}else{toji="yoko"};

//ページ幅を確認→pWidth
var pWidth ;
pWidth = doc.documentPreferences.pageWidth;

//ルーラー開始位置を保存

var doc = app.documents[0] ;
var ro = doc.viewPreferences.rulerOrigin ;  //元の開始位置

//ルーラー開始位置をスプレッドに変更（全ドキュメント）
for (d=0; d<docLength; d++) {
app.documents[d].viewPreferences.rulerOrigin = RulerOrigin.SPREAD_ORIGIN;
}

filename = File.openDialog("用語リストを指定してください");

if (filename){
 
 function createIndex(a){
app.findGrepPreferences.findWhat = a;
app.changeGrepPreferences.changeTo = "";
try{
    var gr=range.findGrep(); // 検索だけ
    var grl=gr.length; 
    if(grl==0){
        myList=myList+"\r"+a+"\t★該当なし★";
        }
   
    for (i=0; i<grl; i++) { 
//try {
var ho = gr[i].horizontalOffset;    //先頭文字の左上X座標
var myTF = gr[i].parentTextFrames[0];   //テキストフレーム
var pageName = myTF.parentPage.name;    //ページ
 
//先頭文字は左右どちらのページに存在するか
var myPosition = "lt" ;
if( ho > pWidth ){myPosition = "rt" };

//場合分け（テキストフレームの所属ページが奇数か偶数か確認しながら）
if( toji == "tate" && myPosition == "lt" && pageName % 2 == 0){ pageName = pageName*1+1 };  //縦組み・座標が左なのにページが偶数→プラス1
if( toji == "tate" && myPosition == "rt" && pageName % 2 != 0){ pageName = pageName*1-1 };  //縦組み・座標が右なのにページが奇数→マイナス1
if(pageName!=doc.pages[0].name){
if( toji == "yoko" && myPosition == "lt" && pageName % 2 != 0){ pageName = pageName*1-1 };  //横組み・座標が左なのにページが奇数→マイナス1（先頭ページを除く）
}
if( toji == "yoko" && myPosition == "rt" && pageName % 2 == 0){ pageName = pageName*1+1 };  //横組み・座標が右なのにページが偶数→プラス1
myList=(myList+"\r"+gr[i].contents+"\t"+pageName);

}
}catch (e) {};
//「ここまでインデント」文字、先頭文字スタイルの終了文字、結合なし、強制改行、脚注番号マーカ、索引マーカ、アンカーマーカ、分割文字などを削除
myList=myList.replace(/\r/g,"〓§〓\r"); 
myList=myList.replace(/[\u0007\u0003\u200C\n\u0004\uFEFF\uFEFC\u000D]/g,"");	
myList=myList.replace(/[\u2011]/g,"-");	//分散禁止ハイフンをハイフンに置換
myList=myList.replace(/〓§〓/g,"\r"); 
myList=myList.replace(/\r☆*\r/g,"\r"); 
myList=myList.replace(/^\r/g,""); 
flag = fileObj.open("w");
if (flag){
fileObj.writeln(myList);
fileObj.close();

////ソート/////

//文字列を生成
myList=("");

//配列を作成
var ary = [];
flagA = fileObj.open("r");
if (flagA)
{
countA = 0;
TAB = String.fromCharCode(9);	// タブコード

while(!fileObj.eof)
{
textA = fileObj.readln();	//　１行読み込む
txtItemA = textA.split(TAB);	//　タブコードで分割
ary.push(txtItemA);//配列の最後に行を追加
countA++;
}
var  lineNum = countA ;	//行数
var rowNum = txtItemA.length;	//列数
}
function funcCompare(a, b) {
	if (a[0] < b[0]) return -1;
	if (a[0] > b[0]) return 1;

	if (a[rowNum-1]*1 < b[rowNum-1]*1) return -1;
	if (a[rowNum-1]*1 > b[rowNum-1]*1) return 1;
	return 0;
}
var newAry=ary.sort(funcCompare);
var aLength = newAry.length;

for( i=0 ; i<aLength ; i++ ){
var newTxt = newAry[i].join( "\t" );
myList = myList + newTxt + "\r" ;
}
//alert(myList)
flag = fileObj.open("w");
if (flag){
fileObj.writeln(myList);
fileObj.close();
}

/////重複削除/////

myList=("");
TAB = String.fromCharCode(9);	// タブコード

//配列を作成
var ary = [];
flagA = fileObj.open("r");
if (flagA)
{
countA = 0;
while(!fileObj.eof)
{
textA = fileObj.readln();	//　１行読み込む
textA="!!"+textA;   //行頭に「!!」を追加（ソートで先頭に出すため）
txtItemA = textA.split(TAB);	//　タブコードで分割
ary.push(txtItemA);//配列の最後に行を追加
countA++;
}
var rowNum = txtItemA.length;	//列数
}

//語句（1列目）とノンブル（最終列）が重複していたら行を削除する。
for( i=ary.length-1 ; i>0 ; i-- ){
if( ary[i][0]==ary[i-1][0] && ary[i][rowNum-1]==ary[i-1][rowNum-1] ){
ary.splice(i, 1);
}
}

//語句（1列目）の重複があったらノンブルを「, 」区切りでまとめる。
for( j=ary.length-1 ; j>0 ; j-- ){
if( ary[j][0]==ary[j-1][0] ){
//alert(ary[i][0]);
ary[j-1][rowNum-1]=ary[j-1][rowNum-1]+", "+ary[j][rowNum-1];
ary.splice(j, 1);
}
}

//ファイルに書き込み保存。
for( k=0 ; k<ary.length ; k++ ){
var newTxt = ary[k].join( "\t" );
myList = myList + newTxt + "\r" ;
myList = myList.replace(/\r+/g,"\r");
myList = myList.replace(/^\r/g,"");
}

flag = fileObj.open("w");
if (flag){
fileObj.writeln(myList);
fileObj.close();
};
}else{
alert("ファイルが作成できません。アクセス権があるか確認してください");
}
var docName = app.documents[0].name.replace(/\.indd/g,"");
now = new Date();
myYear = now.getFullYear();
myMonth=now.getMonth()+1;
myDate=now.getDate();
myHours=now.getHours();
myMinutes=now.getMinutes();
mySeconds=now.getSeconds();
nowTime= myYear +"-"+myMonth+"-"+myDate+"-"+myHours+"-"+myMinutes+"-"+mySeconds;

fileObj.rename( docName+"（索引）"+ nowTime+".txt");
}

fileObj2 = new File(filename);
var lineArr = new Array();
fileObj2.open("r"); // 読み込みモード
while(!fileObj2.eof) {
	var koumoku= fileObj2.readln();
    createIndex(koumoku);
    }
fileObj2.close();
app.findGrepPreferences.findWhat = "" ;
flag = fileObj.open("w");
if (flag){
    myList = myList.replace(/\!\!/g,"");    //!!を削除
    alert("索引ファイルはInDesignドキュメントと同階層に保存されます\r"+myList)
fileObj.writeln(myList);
fileObj.close();
};
};

//ルーラー開始位置を元に戻す（全ドキュメント）
for (d=0; d<docLength; d++) {
app.documents[d].viewPreferences.rulerOrigin = ro; 
}
